\name{TauMatrix}      
\alias{TauMatrix}

\title{Matrix of empirical Kendall's tau values}

\description{
This function computes the empirical Kendall's tau using the algorithm by Knight (1966).
}

\usage{
TauMatrix(data)
}

\arguments{
  \item{data}{An N x d data matrix.}
}

\value{
Matrix of the empirical Kendall's taus. 
}

\references{

Knight, W. R. (1966).
A computer method for calculating Kendall's tau with ungrouped data.
Journal of the American Statistical Association 61 (314), 436-439.

}

\author{Ulf Schepsmeier}

\seealso{\code{\link{BiCopTau2Par}}, \code{\link{BiCopPar2Tau}}, \code{\link{BiCopEst}}}

\examples{
data(daxreturns)
Data = as.matrix(daxreturns)

# compute the empirical Kendall's taus
tau = TauMatrix(Data)
}

